﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Globalization;
using System.Text.RegularExpressions;

namespace ARM_spec_otdelenia
{
    public partial class AddUser : Form
    {
        SqlConnection connection;
        SqlCommand command;
        SqlDataAdapter adapter;
        public AddUser()
        {
            InitializeComponent();
            connection = new SqlConnection("Server=DESKTOP-2UUHBK8\\SQLEXPRESS; Database=Спец_отделение; Trusted_connection=true;");
            command = new SqlCommand();
            command.Connection = connection;
            command.CommandType = CommandType.Text;
            adapter = new SqlDataAdapter(command);
        }
        private void saveBtn_MouseMove(object sender, MouseEventArgs e)
        {
            saveBtn.ForeColor = Color.FromArgb(24, 186, 96);
            saveBtn.FlatAppearance.BorderColor = Color.FromArgb(24, 186, 96);
        }
        private void backBtn_MouseMove(object sender, MouseEventArgs e)
        {
            backBtn.ForeColor = Color.FromArgb(24, 186, 96);
            backBtn.FlatAppearance.BorderColor = Color.FromArgb(24, 186, 96);
        }
        private void backBtn_MouseLeave(object sender, EventArgs e)
        {
            backBtn.ForeColor = Color.Black;
            backBtn.FlatAppearance.BorderColor = Color.Black;
        }
        private void saveBtn_MouseLeave(object sender, EventArgs e)
        {
            saveBtn.ForeColor = Color.Black;
            saveBtn.FlatAppearance.BorderColor = Color.Black;
        }
        public static bool IsValidEmail(string email)
        {
            if (string.IsNullOrWhiteSpace(email))
                return false;
            try
            {
                // Normalize the domain
                email = Regex.Replace(email, @"(@)(.+)$", DomainMapper,
                                      RegexOptions.None, TimeSpan.FromMilliseconds(200));
                // Examines the domain part of the email and normalizes it.
                string DomainMapper(Match match)
                {
                    var idn = new IdnMapping();
                    string domainName = idn.GetAscii(match.Groups[2].Value);
                    return match.Groups[1].Value + domainName;
                }
            }
            catch (RegexMatchTimeoutException e)
            {
                MessageBox.Show(e.Message);
                return false;
            }
            catch (ArgumentException e)
            {
                MessageBox.Show(e.Message);
                return false;
            }

            try
            {
                return Regex.IsMatch(email,
                    @"^[^@\s]+@[^@\s]+\.[^@\s]+$",
                    RegexOptions.IgnoreCase, TimeSpan.FromMilliseconds(250));
            }
            catch (RegexMatchTimeoutException)
            {
                return false;
            }
        }

        private void saveBtn_Click(object sender, EventArgs e)
        {
            var change = new AdminForm();
            if (UsersClass.add == true)
            {
                if (string.IsNullOrEmpty(logText.Text) || string.IsNullOrEmpty(mailText.Text) || string.IsNullOrEmpty(pasText.Text))
                {
                    MessageBox.Show("Не все поля заполнены!");
                    return;
                }
                if (IsValidEmail(mailText.Text) == false)
                {
                    MessageBox.Show("Почта введена некорректно!");
                    return;
                }
                using (var db = new ARMClassesDataContext())
                {
                    var log = db.Пользователи.FirstOrDefault(u => logText.Text == u.Логин);
                    var mail = db.Пользователи.FirstOrDefault(m => mailText.Text == m.Почта);
                    if (log != null)
                    {
                        MessageBox.Show("Логин уже существует в базе!");
                        return;
                    }
                    if (mail != null)
                    {
                        MessageBox.Show("Почта уже существует в базе!");
                        return;
                    }
                    else
                    {
                        if (MessageBox.Show("Вы действительно хотите добавить нового пользователя?", "Внимание", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                        {
                            try
                            {
                                connection.Open();
                                command.CommandText = "INSERT INTO Пользователи(Логин, Почта, Пароль) VALUES(@log, @mail, @pas)";
                                command.Parameters.AddWithValue("@log", logText.Text);
                                command.Parameters.AddWithValue("@mail", mailText.Text);
                                command.Parameters.AddWithValue("@pas", pasText.Text);
                                command.ExecuteReader();
                                command.Parameters.Clear();
                                connection.Close();
                                MessageBox.Show("Пользователь успешно добавлен!");
                                this.Close();
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Show(ex.Message);
                                command.Parameters.Clear();
                                connection.Close();
                            }
                        }
                        else
                        {

                        }
                    }
                }
            }
            if (UsersClass.change == true)
            {
                if (string.IsNullOrEmpty(logText.Text) || string.IsNullOrEmpty(mailText.Text) || string.IsNullOrEmpty(pasText.Text))
                {
                    MessageBox.Show("Не все поля заполнены!");
                    return;
                }
                if (IsValidEmail(mailText.Text) == false)
                {
                    MessageBox.Show("Почта введена некорректно!");
                    return;
                }
                using (var db = new ARMClassesDataContext())
                {
                    var log = db.Пользователи.FirstOrDefault(u => logText.Text == u.Логин);
                    var mail = db.Пользователи.FirstOrDefault(m => mailText.Text == m.Почта);
                    if (UsersClass.login == "Admin" && logText.Text != "Admin")
                    {
                        MessageBox.Show("Этот логин нельзя поменять!");
                        return;
                    }
                    else
                    {
                        if (MessageBox.Show("Вы действительно хотите изменить данные пользователя?", "Внимание", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                        {
                            try
                            {
                                connection.Open();
                                command.CommandText = "UPDATE Пользователи SET Логин=@log, Пароль=@pas, Почта=@mail WHERE Логин=@id";
                                command.Parameters.AddWithValue("@log", logText.Text);
                                command.Parameters.AddWithValue("@mail", mailText.Text);
                                command.Parameters.AddWithValue("@pas", pasText.Text);
                                command.Parameters.AddWithValue("@id", UsersClass.login);
                                command.ExecuteReader();
                                command.Parameters.Clear();
                                connection.Close();
                                MessageBox.Show("Пользователь успешно изменен!");
                                this.Close();
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Show(ex.Message);
                                command.Parameters.Clear();
                                connection.Close();
                            }
                        }
                        else
                        {

                        }
                    }
                }
            }
        }
    }
}
